#> The Commands described in this section are these introduced by
#> Motif Version 2.0. Note that in Wafe versions compiled with Motif 2.0
#> the commands from sections Motif 1.1 to 2.0 are available.

$PACKAGE = "MOTIF20";

#include <X11/Shell.h>
#include <Xm/RepType.h>
#include <Xm/Text.h>
#include <Xm/Scale.h>
#include <Xm/ScrolledW.h>

~handles 
	MOTIF20

~require
motif20.inc
	quark XmRSet
        quark XmRDynamicPixmap
	init wafeRegisterXpmTypeConverter(XmRDynamicPixmap, True);

# modifyVerify and valueChanged callback not handled bidirectionally yet for
# XmCSText, XmComboBox

~widgetClass 
XmCSText
	include <Xm/CSText.h>
        losingFocus|modifyVerify|motionVerify i XmTextPosition: \
                ((XmCSTextVerifyCallbackStruct *)callData)->currInsert \
			# position of insert cursor
        losingFocus|modifyVerify|motionVerify n XmTextPosition: \
                ((XmCSTextVerifyCallbackStruct *)callData)->newInsert \
			# new position of insert cursor
        losingFocus|modifyVerify f XmTextPosition: \
                ((XmCSTextVerifyCallbackStruct *)callData)->startPos \
			# startPos (from)
        losingFocus|modifyVerify t XmTextPosition: \
                ((XmCSTextVerifyCallbackStruct *)callData)-> endPos \
			# endPos (to)
        modifyVerify s EscapedXmString: \
                ((XmCSTextVerifyCallbackStruct *)callData)->text \
			# text

void
XmCSTextReplace
	in: XmCSTextWidget 	# Compound String Text widget
	in: XmTextPosition	# from character position
	in: XmTextPosition	# to character position
	in: XmString 		# insert string

~pseudoWidgetClass 
XmScrolledCSText
	className XmCSText
	createCmd XmCreateScrolledCSText


~widgetClass 
XmComboBox
	include <Xm/ComboBox.h>
        selection s EscapedXmString: \
	    ((XmComboBoxCallbackStruct *)callData)->item_or_text # item or text
        selection p int: \
	    ((XmComboBoxCallbackStruct *)callData)->item_position # position


# widget list for container select callback struct not implemented yet

~widgetClass 
XmContainer
	include <Xm/Container.h>
        outlineChanged a WidgetID: \
	    (WidgetID)((XmContainerOutlineCallbackStruct *)callData)->item \
	                # widget id of affected item 

#define xmIconGadgetWidgetClass xmIconGadgetClass

~widgetClass 
XmIconGadget
	include <Xm/IconG.h>

~widgetClass 
XmNotebook
	include <Xm/Notebook.h>
        pageChanged p int: \
	    ((XmNotebookCallbackStruct *)callData)->page_number \
	                # page number of current page
        pageChanged i WidgetID: \
	    (WidgetID)((XmNotebookCallbackStruct *)callData)->page_widget \
	                # widget id of current page
        pageChanged P int: \
	    ((XmNotebookCallbackStruct *)callData)->prev_page_number \
	                # page number of previous page
        pageChanged I WidgetID: \
	    (WidgetID)((XmNotebookCallbackStruct *)callData)->prev_page_widget \
	                # widget id of previous page

#> The command 'XmScaleSetTicks' controls the number, location and
#> size of the tick marks on a scale. Each tick mark is implemented as
#> a separator gadget. If tick marks are specified and the orientation
#> of the XmScale widget is changed, it is necessary to destroy all
#> children of the XmScale widget and to recreate new tick marks using
#> XmScaleSetTicks again.

void
XmScaleSetTicks
	in: XmScaleWidget	# XmScale widget
	in: int			# number of scale values between big ticks
	in: Cardinal		# number of medium ticks between big values
	in: Cardinal		# number of small ticks between medium values
	in: Dimension		# size of big ticks
	in: Dimension		# size of medium ticks
	in: Dimension		# size of small ticks

~widgetClass 
XmSpinBox
	include <Xm/SpinB.h>
	modifyVerify|valueChanged s EscapedXmString: \
		((XmSpinBoxCallbackStruct *)callData)->value 	# string value
	modifyVerify|valueChanged a WidgetID: \
		(WidgetID) ((XmSpinBoxCallbackStruct *)callData)->widget \
			# widgetID of affected widget
	modifyVerify|valueChanged p int: \
		((XmSpinBoxCallbackStruct *)callData)->position \
			# position
	modifyVerify|valueChanged b int: \
		((XmSpinBoxCallbackStruct *)callData)->crossed_boundary \
			# crossed boundary

