proc changePixmap-type {} { return {function {} {in: Widget} {in: String} {in: String} ## {widget} {resource} {pixmap file}}}
set wafeCmdNeeds(changePixmap) {XPM }

proc setBusy-type {} { return {function {void} {in: Widget} {in: Boolean} ## {shell widget} {sensitive true | false}}}
set wafeHelp(setBusy) { The command 'setBusy' sets the given widget (typically a shell
 widget) and its children busy or not, depending on the boolean
 'state' argument (2nd argument). If a widget is set busy, a
 busy-cursor is set and input is inhibited for all children
 widgets. The appearance of the children widgets will not change.
 If a shell is set busy and set non-busy some time later, all the
 sensitivity states before the setBusy command are reestablished.
 
 Per default a watch is used as the busy cursor; the default busy
 cursor can be altered by the command 'setDefaultBusyCursor'. In
 order to change only the cursor (for any widget) without
 prohibiting input, use the command 'setCursor'.}

proc isBusy-type {} { return {function {Boolean} {in: Widget} ## {Widget to test}}}
set wafeHelp(isBusy) { The function 'isBusy' returns the busy state of the specified widget.}

proc setCursor-type {} { return {function {void} {in: Widget} {in: String} {in: [args opt]} ## {widget} {cursor name} {optional foreground, optional background}}}
set wafeHelp(setCursor) { The command 'setCursor' can be used to change the cursor in the
 specified widget. The name of the cursor (2nd argument) can refer
 to the name of a cursor in the cursor font (e.g. "pirate") or it
 can refer to a x bitmap file (.xbm-file). If there exists a mask
 file with the same name, and "msk" or "Mask" appended, in the same
 directory it is used as a mask for the cursor. An x bitmap file is
 searched along FILESEARCHPATH. Optionally the forground color of
 the cursor can be specified as third argument, the background color
 can be optionally specified as the fourth argument.}

